<template lang="pug">
Loader(loading, title="Logging you in anonymously...")
</template>

<script>
import { EventBus } from "@/components/event-bus.js";
import Loader from "@/components/Loader.vue";
import { auth, functions } from "../db";
const decryptToken = functions.httpsCallable("decryptToken");

export default {
  name: "Anonymous",
  components: { Loader },
  data() {
    return {
      token: this.$route.query.token,
      user: {},
    };
  },
  created: function () {
    this.signInAnonymously();
  },
  methods: {
    async signInAnonymously() {
      if (!this.token) {
        console.log("Missing Token...");
        return this.$router.push("/");
      }

      let curMeetingid;
      let curHostuid;
      auth
        .signInAnonymously()
        .then(async loginData => {
          this.user = loginData.user;

          // Read result of the decryptToken Function
          const result = await decryptToken({ token: this.token });
          const { meetingid, hostuid } = result.data;
          curMeetingid = meetingid;
          curHostuid = hostuid;
          const anonymousSession = {
            hostuid: curHostuid,
            meetingid: curMeetingid,
          };
          this.$cookies.set("anonymous", anonymousSession, "1d");
          return loginData.user.getIdToken();
        })
        .then(async idToken => {
          this.$cookies.set("session", idToken, "1h");
          EventBus.$emit("logged-in");
          this.$router.push("/" + curMeetingid);
        })
        .catch(error => {
          console.log("Error " + error.code + ": " + error.message);
          return this.$router.push("/");
        });
    },
  },
};
</script>

<style scoped></style>
